<!doctype html>
<html xmlns:th="http://www.thymeleaf.org">
<head>
    <base th:href="${#request.getContextPath() + '/'}">
    <meta charset="utf-8">
    <meta name="renderer" content="webkit">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=0">
    <link rel="stylesheet" href="assets/fonts/font-awesome/css/font-awesome.css"/>
    <link rel="stylesheet" href="assets/layuiadmin/layui/css/layui.css" media="all">
    <link rel="stylesheet" href="assets/layuiadmin/style/admin.css" media="all">
</head>
<body>
<div class="layui-fluid layui-anim layui-anim-fadein">
    <div class="layui-row">
        <div class="layui-col-md12">
            <div class="layui-card">
                <div class="layui-card-body">
                    <div class="test-table-reload-btn" style="margin-bottom: 10px;">
                        <div class="layui-inline">
                            <input type="text" id="keywords" class="layui-input search-item" placeholder="输入关键字">
                        </div>
                        <div class="layui-inline">
                            <input type="text" id="startTime" class="layui-input search-item" placeholder="开始时间" readonly>
                        </div>
                        <div class="layui-inline">
                            <input type="text" id="endTime" class="layui-input search-item" placeholder="结束时间" readonly>
                        </div>
                        <button type="button" id="search" class="layui-btn layui-btn-sm">
                            <i class="fa fa-lg fa-search"></i> 搜索
                        </button>
                    </div>
                    <table class="layui-hide" id="dataTable" lay-filter="dataTable"></table>
                    <!-- 表头按钮组 -->
                    <script type="text/html" id="headerToolBar">
                        <div class="layui-btn-group">
                            <button type="button" class="layui-btn layui-btn-sm" lay-event="saveEvent">
                                <i class="fa fa-lg fa-plus"></i> 新增
                            </button>
                            <button type="button" class="layui-btn layui-btn-normal layui-btn-sm" lay-event="updateEvent">
                                <i class="fa fa-lg fa-edit"></i> 编辑
                            </button>
                            <button type="button" class="layui-btn layui-btn-danger layui-btn-sm" lay-event="removeEvent">
                                <i class="fa fa-lg fa-trash"></i> 删除
                            </button>
                            <button type="button" class="layui-btn layui-btn-sm" lay-event="actionEvent">
                                <i class="fa fa-lg fa-microchip "></i> 激活表单
                            </button>
                            <button type="button" class="layui-btn layui-btn-normal layui-btn-sm" lay-event="fieldOrderEvent">
                                <i class="fa fa-lg fa-bars "></i> 表单布局
                            </button>
                        </div>
                    </script>
                </div>
            </div>
        </div>
    </div>
</div>

<div class="layui-collapse" lay-accordion style="display: none" id="actionMessage">
    <div class="layui-colla-item">
        <h2 class="layui-colla-title" style="color:red">激活后将会创建实体表，激活前请确认配置无误</h2>
    </div>
    <div class="layui-colla-item">
        <h2 class="layui-colla-title" style="color:red">激活后再可以修改表单吗？</h2>
        <div class="layui-colla-content layui-show" >激活后可以修改 表单描述、备注内容。不支持修改 表单编号、数据库表名、数据形式。</div>
    </div>
    <div class="layui-colla-item">
        <h2 class="layui-colla-title" style="color:red">激活后再可以修改字段吗？</h2>
        <div class="layui-colla-content layui-show" >激活后可以修改 字段名称、字段排序、是否必填、字段描述。不支持修改 列名、字段类型、存储数量。</div>
    </div>
</div>
<script src="assets/layuiadmin/layui/layui.js"></script>
<script src="assets/js/vendor/viewer/viewer.min.js"></script>
<script>
    layui.config({
        base: 'assets/layuiadmin/'
    }).extend({
        index: 'lib/index'
    }).use(['element','index', 'table', 'laydate', 'common'], function() {
        var $ = layui.$;
        var $win = $(window);
        var table = layui.table;
        var admin = layui.admin;
        var laydate = layui.laydate;
        var element = layui.element;
        var common = layui.common;
        var resizeTimeout = null;
        var tableUrl = 'api/configtable/listpage';

        // 初始化表格
        function initTable() {
            table.render({
                elem: '#dataTable',
                id: 'dataTable',
                url: top.restAjax.path(tableUrl, []),
                width: admin.screen() > 1 ? '100%' : '',
                height: $win.height() - 90,
                limit: 20,
                limits: [20, 40, 60, 80, 100, 200],
                toolbar: '#headerToolBar',
                request: {
                    pageName: 'page',
                    limitName: 'rows'
                },
                cols: [
                    [
                        {type:'checkbox', fixed: 'left'},
                        {field:'rowNum', width:80, title: '序号', fixed: 'left', align:'center', templet: '<span>{{d.LAY_INDEX}}</span>'},
                        {field: 'configTableNumber', width: 100, title: '表单编号', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'configTableCode', width: 200, title: '数据库表名', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'configTableFieldList', width: 100, title: '字段数量', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                return '<b>' + rowData.length + '</b>';
                            }
                        },
                        {field: 'configTableActivation', width: 120, title: '激活状态',  fixed: 'right', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(rowData == 1) {
                                    return  '<button type="button"  class="layui-btn layui-btn-xs">已激活</button>';
                                }else {
                                    return '<button type="button" class="layui-btn layui-btn-danger layui-btn-xs">未激活</button>'
                                }
                            }
                        },
                        {field: 'configTableMode', width: 180, title: '数据形式',  fixed: 'right', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(rowData == 1) {
                                    return '<button type="button" class="layui-btn layui-btn-danger layui-btn-xs">单数据(每个用户一条数据)</button>'
                                }else {
                                    return  '<button type="button"  class="layui-btn layui-btn-xs">多数据(每个用户多条数据)</button>';
                                }
                            }
                        },
                        {field: 'configTableName', width: 200, title: '表单描述',  fixed: 'right', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field:'picturesTemplateAreaEvent', width:120, title: '数据库数据', fixed: 'right', align:'center',
                            templet: function(row) {
                                var rowData = row['configTableActivation'];
                                if(rowData == 1) {
                                    return '<button  lay-event="configTableOperationEvent" type="button" class="layui-btn layui-btn-xs layui-btn-radius">数据库数据</button>';
                                }else {
                                    return '-';
                                }

                            }
                        }
                    ]
                ],
                page: true,
                parseData: function(data) {
                    return {
                        'code': 0,
                        'msg': '',
                        'count': data.total,
                        'data': data.rows
                    };
                }
            });
        }
        // 重载表格
        function reloadTable(currentPage) {
            table.reload('dataTable', {
                url: top.restAjax.path(tableUrl, []),
                where: {
                    keywords: $('#keywords').val(),
                    startTime: $('#startTime').val(),
                    endTime: $('#endTime').val()
                },
                page: {
                    curr: currentPage
                },
                height: $win.height() - 90,
            });
        }
        // 初始化日期
        function initDate() {
            // 日期选择
            laydate.render({
                elem: '#startTime',
                format: 'yyyy-MM-dd'
            });
            laydate.render({
                elem: '#endTime',
                format: 'yyyy-MM-dd'
            });
        }
        // 删除
        function removeData(ids) {
            top.dialog.msg(top.dataMessage.delete, {
                time: 0,
                btn: [top.dataMessage.button.yes, top.dataMessage.button.no],
                shade: 0.3,
               /* yes: function (index) {
                    top.dialog.close(index);
                    var layIndex;
                    top.restAjax.delete(top.restAjax.path('api/configtable/remove/{ids}', [ids]), {}, null, function (code, data) {
                        top.dialog.msg(top.dataMessage.deleteSuccess, {time: 1000});
                        reloadTable();
                    }, function (code, data) {
                        top.dialog.msg(data.msg);
                    }, function () {
                        layIndex = top.dialog.msg(top.dataMessage.deleting, {icon: 16, time: 0, shade: 0.3});
                    }, function () {
                        top.dialog.close(layIndex);
                    });
                }*/
                btn:['仅删除当前','并删除数据库表','取消'],
                btn1: function (index) {
                    top.dialog.close(index);
                    var layIndex;
                    top.restAjax.delete(top.restAjax.path('api/configtable/remove/{ids}', [ids]), {}, null, function (code, data) {
                        top.dialog.msg(top.dataMessage.deleteSuccess, {time: 1000});
                        reloadTable();
                    }, function (code, data) {
                        top.dialog.msg(data.msg);
                    }, function () {
                        layIndex = top.dialog.msg(top.dataMessage.deleting, {icon: 16, time: 0, shade: 0.3});
                    }, function () {
                        top.dialog.close(layIndex);
                    });
                },
                btn2: function (index) {
                    top.dialog.close(index);
                    var layIndex;
                    top.restAjax.delete(top.restAjax.path('api/configtable/removetable/{ids}', [ids]), {}, null, function (code, data) {
                        top.dialog.msg(top.dataMessage.deleteSuccess, {time: 1000});
                        reloadTable();
                    }, function (code, data) {
                        top.dialog.msg(data.msg);
                    }, function () {
                        layIndex = top.dialog.msg(top.dataMessage.deleting, {icon: 16, time: 0, shade: 0.3});
                    }, function () {
                        top.dialog.close(layIndex);
                    });
                },
                btn3: function (index) {
                }
            });
        }
        initTable();
        initDate();
        // 事件 - 页面变化
        $win.on('resize', function() {
            clearTimeout(resizeTimeout);
            resizeTimeout = setTimeout(function() {
                reloadTable();
            }, 500);
        });
        // 事件 - 搜索
        $(document).on('click', '#search', function() {
            reloadTable(1);
        });

        // 表格行中按钮事件
        table.on('tool(dataTable)', function(obj) {
            var layEvent = obj.event;
            var data = obj.data;
            if(layEvent === 'configTableOperationEvent') {
                top.dialog.open({
                    url: top.restAjax.path('route/configtableoperation/list?configTableCode={configTableCode}', [data.configTableCode]),
                    title: "数据库表名 : " + data.configTableCode,
                    width: '90%',
                    height: '90%',
                    onClose: function() {
                        reloadTable();
                    }
                });
            }
        });

        // 事件 - 增删改
        table.on('toolbar(dataTable)', function(obj) {
            var layEvent = obj.event;
            var checkStatus = table.checkStatus('dataTable');
            var checkDatas = checkStatus.data;
            if(layEvent === 'saveEvent') {
                layer.open({
                    type: 2,
                    title: false,
                    closeBtn: 0,
                    area: ['100%', '100%'],
                    shadeClose: true,
                    anim: 2,
                    content: top.restAjax.path('route/configtable/save', []),
                    end: function() {
                        reloadTable();
                    }
                });
            } else if(layEvent === 'updateEvent') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectEdit);
                } else if(checkDatas.length > 1) {
                    top.dialog.msg(top.dataMessage.table.selectOneEdit);
                } else {
                    layer.open({
                        type: 2,
                        title: false,
                        closeBtn: 0,
                        area: ['100%', '100%'],
                        shadeClose: true,
                        anim: 2,
                        content: top.restAjax.path('route/configtable/update?configTableId={configTableId}', [checkDatas[0].configTableId]),
                        end: function() {
                            reloadTable();
                        }
                    });
                }
            } else if(layEvent === 'removeEvent') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectDelete);
                } else {
                    var ids = '';
                    for(var i = 0, item; item = checkDatas[i++];) {
                        if(i > 1) {
                            ids += '_';
                        }
                        ids += item['configTableId'];
                    }
                    removeData(ids);
                }
            }else if(layEvent === 'actionEvent') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectEdit);
                } else if(checkDatas.length > 1) {
                    top.dialog.msg(top.dataMessage.table.selectOneEdit);
                } else {
                    if(checkDatas[0].configTableActivation == "1") {
                        top.layer.msg("该数据已经是激活状态");
                        return;
                    }else{
                        top.layer.open({
                            type: 1,
                            title: false,
                            btn: ['立即激活创建实体版','再想想'],
                            closeBtn: 0,
                            area: ["550px" , "320px"],
                            shadeClose: true,
                            anim: 2,
                            btn1:function(index) {
                                top.layer.close(index);
                                var layIndex;
                                top.restAjax.put(top.restAjax.path('api/configtable/action/{configTableId}', [checkDatas[0].configTableId]), {}, null, function (code, data) {
                                    top.dialog.msg("表单激活成功", {time: 1000});
                                    reloadTable();
                                }, function (code, data) {
                                    top.dialog.msg(data.msg);
                                }, function () {
                                    layIndex = top.dialog.msg("表单激活中.....", {icon: 16, time: 0, shade: 0.3});
                                }, function () {
                                    top.dialog.close(layIndex);
                                });
                            },
                            btn2:function(index) {1
                                top.layer.close(index);
                            },
                            content: $("#actionMessage").html(),
                            end: function() {
                                reloadTable();
                            },success:function() {
                            }
                        });
                    }
                }
            }else if(layEvent === 'fieldOrderEvent') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectEdit);
                } else if(checkDatas.length > 1) {
                    top.dialog.msg(top.dataMessage.table.selectOneEdit);
                } else {
                    if(checkDatas[0].configTableActivation == "0") {
                        top.layer.msg("激活后的表单才可以进行布局");
                        return;
                    }else{
                        top.layer.open({
                            type: 2,
                            title: false,
                            closeBtn: 1,
                            area: ["95%" , "95%"],
                            shadeClose: true,
                            anim: 2,
                            content: top.restAjax.path('route/configtable/listfield?configTableId={configTableId}', [checkDatas[0].configTableId]),
                            end: function() {
                                reloadTable();
                            },success:function() {
                            }
                        });
                    }
                }
            }
        });
    });
</script>
</body>
</html>